$offlisting

* By Adam Blake

* Store - stores values of each variable in the call line
*        under a name given by the first variable


* First invocation must be outside a loop !
* Commands:
* $libinclude Store simname var1 var2 var3 ...
*	- records values of the designated variables/parameters
* $libinclude Store these var1 var2 var3 ...
*	- stores variable names so that subsequently,
* $libinclude Store simname
*	- records values of variables given by the "these" command
* $libinclude Store display
*	- displays all stored values
* $libinclude Store setbase simname
*	- sets the base simulation for subsequent simulations
* $libinclude Store percent
*	- displays percentage changes from the base simulation
* $libinclude Store changes
*	- displays changes from the base simulation
* $libinclude Store byset setname [var1 var2 var3...]
*	- records values of the designated variables/parameters (or all values designated
*	  in a "store" command) by their set element (useful when solves are nested within a loop)
* $libinclude Store setmodel modelname
*	- necessary if status information is to be stored. modelname is the name of the model (!)
* $libinclude Store calc varname (sets)=expression;
*	- sets up an expression to be included and stored whenever Store is run without designated variables/parameters


$onuni
$if setglobal Stored $goto startcall

file screen /'con'/;
$setglobal sv_store Results Status

set sims(*);
alias(*,SV__1,SV__2,SV__3);
Parameters Status(*,*) Model status
           Results(*,*) Single-column results
	   ResultsCh(*,*) Changes in single-column results
	   ResultsPer(*,*) Percentage changes in single-column results;
Status("_","_")=0;
Results("_","_")=0;
ResultsCh("_","_")=0;
ResultsPer("_","_")=0;
$setglobal Stored Status
$setglobal SV_Per ResultsPer
$setglobal SV_Change ResultsCh
set SimBase "Which simulations (rows) are based to which base simulations (columns)";
SimBase("_","_") = NO;


*===============
$label startcall
*===============
$if "%1"=="" $goto end

$if "%1"=="display" $goto display
$if "%1"=="percent" $goto percent
$if "%1"=="changes"  $goto change
$if "%1"=="setbase" $goto setbase
$if "%1"=="these"   $goto storethese
$if "%1"=="byset"   $goto byset
$if "%1"=="setmodel" $goto setmodel
$if "%1"=="calc" $goto storecalc


$setglobal Storename %1
sims("%1") = yes;

$if "%2"=="" $goto noparams


* A standard call, with parameters specified:
put screen; put //"STORING %1" //; putclose;
$label param_loop
$shift
$if "%1"=="" $goto end
$libinclude Store1.inc  %1
$goto param_loop


* A standard call, without parameters
$label noparams
$if "%to_store%"=="" $goto end
put screen; put //"STORING %1" //; putclose;
$if setglobal to_store  $libinclude Store1.inc %to_store%
$if setglobal to_store1 $libinclude Store1.inc %to_store1%
$if setglobal to_store2 $libinclude Store1.inc %to_store2%
$if setglobal to_store3 $libinclude Store1.inc %to_store3%
$if setglobal to_store4 $libinclude Store1.inc %to_store4%
$if setglobal to_store5 $libinclude Store1.inc %to_store5%
$if setglobal to_store6 $libinclude Store1.inc %to_store6%
$if setglobal to_store7 $libinclude Store1.inc %to_store7%
$if setglobal to_store8 $libinclude Store1.inc %to_store8%
$if setglobal to_store9 $libinclude Store1.inc %to_store9%
$if setglobal to_store10 $libinclude Store1.inc %to_store10%

$if setglobal calc1 %calc1%
$if setglobal calc2 %calc2%
$if setglobal calc3 %calc3%
$if setglobal calc4 %calc4%
$if setglobal calc5 %calc5%
$if setglobal calc6 %calc6%
$if setglobal calc7 %calc7%
$if setglobal calc8 %calc8%
$if setglobal calc9 %calc9%
$if setglobal calc10 %calc10%
$if setglobal calc11 %calc11%
$if setglobal calc12 %calc12%
$if setglobal calc13 %calc13%
$if setglobal calc14 %calc14%
$if setglobal calc15 %calc15%
$if setglobal calc16 %calc16%
$if setglobal calc17 %calc17%
$if setglobal calc18 %calc18%
$if setglobal calc19 %calc19%
$if setglobal calc20 %calc20%
$if setglobal calc21 %calc21%
$if setglobal calc22 %calc22%
$if setglobal calc23 %calc23%
$if setglobal calc24 %calc24%
$if setglobal calc25 %calc25%
$if setglobal calc26 %calc26%
$if setglobal calc27 %calc27%
$if setglobal calc28 %calc28%
$if setglobal calc29 %calc29%
$if setglobal calc30 %calc30%
$if setglobal calc31 %calc31%
$if setglobal calc32 %calc32%
$if setglobal calc33 %calc33%
$if setglobal calc34 %calc34%
$if setglobal calc35 %calc35%
$if setglobal calc36 %calc36%
$if setglobal calc37 %calc37%
$if setglobal calc38 %calc38%
$if setglobal calc39 %calc39%
$if setglobal calc40 %calc40%
$if setglobal calc41 %calc41%
$if setglobal calc42 %calc42%
$if setglobal calc43 %calc43%
$if setglobal calc44 %calc44%
$if setglobal calc45 %calc45%
$if setglobal calc46 %calc46%
$if setglobal calc47 %calc47%
$if setglobal calc48 %calc48%
$if setglobal calc49 %calc49%
$if setglobal calc50 %calc50%

$if setglobal storecalc1 $libinclude Store1.inc %storecalc1%
$if setglobal storecalc2 $libinclude Store1.inc %storecalc2%
$if setglobal storecalc3 $libinclude Store1.inc %storecalc3%
$if setglobal storecalc4 $libinclude Store1.inc %storecalc4%
$if setglobal storecalc5 $libinclude Store1.inc %storecalc5%

$goto end

*===============
$label byset
*===============
$shift
$setglobal Storename %1
sims(%1) = yes;

put screen; put //"STORING " %1.TL " " %1.TE(%1) //; putclose;
$if "%2"=="" $goto noparbyset


* A standard call, with parameters specified:
$label byset_loop
$shift
$if "%1"=="" $goto end
$libinclude Store2.inc  %1
$goto byset_loop


* A standard call, without parameters
$label noparbyset
$if "%to_store%"=="" $goto end
$if setglobal to_store  $libinclude Store2.inc %to_store%
$if setglobal to_store1 $libinclude Store2.inc %to_store1%
$if setglobal to_store2 $libinclude Store2.inc %to_store2%
$if setglobal to_store3 $libinclude Store2.inc %to_store3%
$if setglobal to_store4 $libinclude Store2.inc %to_store4%
$if setglobal to_store5 $libinclude Store2.inc %to_store5%
$if setglobal to_store6 $libinclude Store2.inc %to_store6%
$if setglobal to_store7 $libinclude Store2.inc %to_store7%
$if setglobal to_store8 $libinclude Store2.inc %to_store8%
$if setglobal to_store9 $libinclude Store2.inc %to_store9%
$if setglobal to_store10 $libinclude Store2.inc %to_store10%

$if setglobal calc1 %calc1%
$if setglobal calc2 %calc2%
$if setglobal calc3 %calc3%
$if setglobal calc4 %calc4%
$if setglobal calc5 %calc5%
$if setglobal calc6 %calc6%
$if setglobal calc7 %calc7%
$if setglobal calc8 %calc8%
$if setglobal calc9 %calc9%
$if setglobal calc10 %calc10%
$if setglobal calc11 %calc11%
$if setglobal calc12 %calc12%
$if setglobal calc13 %calc13%
$if setglobal calc14 %calc14%
$if setglobal calc15 %calc15%
$if setglobal calc16 %calc16%
$if setglobal calc17 %calc17%
$if setglobal calc18 %calc18%
$if setglobal calc19 %calc19%
$if setglobal calc20 %calc20%
$if setglobal calc21 %calc21%
$if setglobal calc22 %calc22%
$if setglobal calc23 %calc23%
$if setglobal calc24 %calc24%
$if setglobal calc25 %calc25%
$if setglobal calc26 %calc26%
$if setglobal calc27 %calc27%
$if setglobal calc28 %calc28%
$if setglobal calc29 %calc29%
$if setglobal calc30 %calc30%
$if setglobal calc31 %calc31%
$if setglobal calc32 %calc32%
$if setglobal calc33 %calc33%
$if setglobal calc34 %calc34%
$if setglobal calc35 %calc35%
$if setglobal calc36 %calc36%
$if setglobal calc37 %calc37%
$if setglobal calc38 %calc38%
$if setglobal calc39 %calc39%
$if setglobal calc40 %calc40%
$if setglobal calc41 %calc41%
$if setglobal calc42 %calc42%
$if setglobal calc43 %calc43%
$if setglobal calc44 %calc44%
$if setglobal calc45 %calc45%
$if setglobal calc46 %calc46%
$if setglobal calc47 %calc47%
$if setglobal calc48 %calc48%
$if setglobal calc49 %calc49%
$if setglobal calc50 %calc50%

$if setglobal storecalc1 $libinclude Store2.inc %storecalc1%
$if setglobal storecalc2 $libinclude Store2.inc %storecalc2%
$if setglobal storecalc3 $libinclude Store2.inc %storecalc3%
$if setglobal storecalc4 $libinclude Store2.inc %storecalc4%
$if setglobal storecalc5 $libinclude Store2.inc %storecalc5%
$goto end



*===============
$label display
*===============
$if set to_store  $libinclude store3.inc v_ %to_store%
$if set to_store1 $libinclude store3.inc v_ %to_store1%
$if set to_store2 $libinclude store3.inc v_ %to_store2%
$if set to_store3 $libinclude store3.inc v_ %to_store3%
$if set to_store4 $libinclude store3.inc v_ %to_store4%
$if set to_store5 $libinclude store3.inc v_ %to_store5%
$if set to_store6 $libinclude store3.inc v_ %to_store6%
$if set to_store7 $libinclude store3.inc v_ %to_store7%
$if set to_store8 $libinclude store3.inc v_ %to_store8%
$if set to_store9 $libinclude store3.inc v_ %to_store9%
$if set to_store10 $libinclude store3.inc v_ %to_store10%
$if set storecalc1 $libinclude store3.inc v_ %storecalc1%
$if set storecalc2 $libinclude store3.inc v_ %storecalc2%
$if set storecalc3 $libinclude store3.inc v_ %storecalc3%
$if set storecalc4 $libinclude store3.inc v_ %storecalc4%
$if set storecalc5 $libinclude store3.inc v_ %storecalc5%

* So it will be at the end of the listing file:
display Results,Status;
$shift
$goto startcall
*===============
$label percent
*===============
$if set to_store  $libinclude store3.inc p_ %to_store%
$if set to_store1 $libinclude store3.inc p_ %to_store1%
$if set to_store2 $libinclude store3.inc p_ %to_store2%
$if set to_store3 $libinclude store3.inc p_ %to_store3%
$if set to_store4 $libinclude store3.inc p_ %to_store4%
$if set to_store5 $libinclude store3.inc p_ %to_store5%
$if set to_store6 $libinclude store3.inc p_ %to_store6%
$if set to_store7 $libinclude store3.inc p_ %to_store7%
$if set to_store8 $libinclude store3.inc p_ %to_store8%
$if set to_store9 $libinclude store3.inc p_ %to_store9%
$if set to_store10 $libinclude store3.inc p_ %to_store10%
$if set storecalc1 $libinclude store3.inc p_ %storecalc1%
$if set storecalc2 $libinclude store3.inc p_ %storecalc2%
$if set storecalc3 $libinclude store3.inc p_ %storecalc3%
$if set storecalc4 $libinclude store3.inc p_ %storecalc4%
$if set storecalc5 $libinclude store3.inc p_ %storecalc5%

display ResultsPer,simbase,status;
$shift
$goto startcall
*===============
$label change
*===============
$if set to_store  $libinclude store3.inc c_ %to_store%
$if set to_store1 $libinclude store3.inc c_ %to_store1%
$if set to_store2 $libinclude store3.inc c_ %to_store2%
$if set to_store3 $libinclude store3.inc c_ %to_store3%
$if set to_store4 $libinclude store3.inc c_ %to_store4%
$if set to_store5 $libinclude store3.inc c_ %to_store5%
$if set to_store6 $libinclude store3.inc c_ %to_store6%
$if set to_store7 $libinclude store3.inc c_ %to_store7%
$if set to_store8 $libinclude store3.inc c_ %to_store8%
$if set to_store9 $libinclude store3.inc c_ %to_store9%
$if set to_store10 $libinclude store3.inc c_ %to_store10%
$if set storecalc1 $libinclude store3.inc c_ %storecalc1%
$if set storecalc2 $libinclude store3.inc c_ %storecalc2%
$if set storecalc3 $libinclude store3.inc c_ %storecalc3%
$if set storecalc4 $libinclude store3.inc c_ %storecalc4%
$if set storecalc5 $libinclude store3.inc c_ %storecalc5%

display ResultsCh,simbase,status;
$shift
$goto startcall
*===============
$label storethese
*===============
$shift
$if "%1"=="" $goto end
$if not setglobal to_store1 $goto these1
$if not setglobal to_store2 $goto these2
$if not setglobal to_store3 $goto these3
$if not setglobal to_store4 $goto these4
$if not setglobal to_store5 $goto these5
$if not setglobal to_store6 $goto these6
$if not setglobal to_store7 $goto these7
$if not setglobal to_store8 $goto these8
$if not setglobal to_store9 $goto these9
$if not setglobal to_store10 $goto these10
  **** store error: more than ten uses of 'store these...'
$goto end

$label these1
$setglobal to_store1 %1
$label mid1
$shift
$if "%1"=="" $goto end
$setglobal to_store1 %to_store1% %1
$goto mid1

$label these2
$setglobal to_store2 %1
$label mid2
$shift
$if "%1"=="" $goto end
$setglobal to_store2 %to_store2% %1
$goto mid2

$label these3
$setglobal to_store3 %1
$label mid3
$shift
$if "%1"=="" $goto end
$setglobal to_store3 %to_store3% %1
$goto mid3

$label these4
$setglobal to_store4 %1
$label mid4
$shift
$if "%1"=="" $goto end
$setglobal to_store4 %to_store4% %1
$goto mid4

$label these5
$setglobal to_store5 %1
$label mid5
$shift
$if "%1"=="" $goto end
$setglobal to_store5 %to_store5% %1
$goto mid5

$label these6
$setglobal to_store6 %1
$label mid6
$shift
$if "%1"=="" $goto end
$setglobal to_store6 %to_store6% %1
$goto mid6

$label these7
$setglobal to_store7 %1
$label mid7
$shift
$if "%1"=="" $goto end
$setglobal to_store7 %to_store7% %1
$goto mid7

$label these8
$setglobal to_store8 %1
$label mid8
$shift
$if "%1"=="" $goto end
$setglobal to_store8 %to_store8% %1
$goto mid8

$label these9
$setglobal to_store9 %1
$label mid9
$shift
$if "%1"=="" $goto end
$setglobal to_store9 %to_store9% %1
$goto mid9

$label these10
$setglobal to_store10 %1
$label mid10
$shift
$if "%1"=="" $goto end
$setglobal to_store10 %to_store10% %1
$goto mid10

*===============
$label setbase
*===============
$if "%2"=="" $goto base_error
$setglobal sv_base %2
$shift
$shift
$goto startcall

$label base_error
$log "**** WARNING - Store received a setbase command, but no base was specified"
$goto end

*===============
$label setmodel
*===============
$if "%2"=="" $goto mod_error
$setglobal modelname %2
$shift
$shift
$goto startcall

$label mod_error
$log "**** WARNING - Store received a setmodel command, but no model was specified"
$goto end

*===============
$label storecalc
*===============
$if "%2"=="" $goto end
$if "%3"=="" $goto end
* Start storecalc
$if not setglobal calc1 $goto set1
$if not setglobal calc2 $goto set2
$if not setglobal calc3 $goto set3
$if not setglobal calc4 $goto set4
$if not setglobal calc5 $goto set5
$if not setglobal calc6 $goto set6
$if not setglobal calc7 $goto set7
$if not setglobal calc8 $goto set8
$if not setglobal calc9 $goto set9
$if not setglobal calc10 $goto set10
$if not setglobal calc11 $goto set11
$if not setglobal calc12 $goto set12
$if not setglobal calc13 $goto set13
$if not setglobal calc14 $goto set14
$if not setglobal calc15 $goto set15
$if not setglobal calc16 $goto set16
$if not setglobal calc17 $goto set17
$if not setglobal calc18 $goto set18
$if not setglobal calc19 $goto set19
$if not setglobal calc20 $goto set20
$if not setglobal calc21 $goto set21
$if not setglobal calc22 $goto set22
$if not setglobal calc23 $goto set23
$if not setglobal calc24 $goto set24
$if not setglobal calc25 $goto set25
$if not setglobal calc26 $goto set26
$if not setglobal calc27 $goto set27
$if not setglobal calc28 $goto set28
$if not setglobal calc29 $goto set29
$if not setglobal calc30 $goto set30
$if not setglobal calc31 $goto set31
$if not setglobal calc32 $goto set32
$if not setglobal calc33 $goto set33
$if not setglobal calc34 $goto set34
$if not setglobal calc35 $goto set35
$if not setglobal calc36 $goto set36
$if not setglobal calc37 $goto set37
$if not setglobal calc38 $goto set38
$if not setglobal calc39 $goto set39
$if not setglobal calc40 $goto set40
$if not setglobal calc41 $goto set41
$if not setglobal calc42 $goto set42
$if not setglobal calc43 $goto set43
$if not setglobal calc44 $goto set44
$if not setglobal calc45 $goto set45
$if not setglobal calc46 $goto set46
$if not setglobal calc47 $goto set47
$if not setglobal calc48 $goto set48
$if not setglobal calc49 $goto set49
$if not setglobal calc50 $goto set50
 **** Storecalc error: more than 50 calculations!
$goto end

$label set1
$setglobal calc1 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc1 %2
$goto endcalcs
$label set2
$setglobal calc2 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc1 %storecalc1% %2 
$goto endcalcs
$label set3
$setglobal calc3 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc1 %storecalc1% %2 
$goto endcalcs
$label set4
$setglobal calc4 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc1 %storecalc1% %2 
$goto endcalcs
$label set5
$setglobal calc5 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc1 %storecalc1% %2 
$goto endcalcs
$label set6
$setglobal calc6 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc1 %storecalc1% %2 
$goto endcalcs
$label set7
$setglobal calc7 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc1 %storecalc1% %2 
$goto endcalcs
$label set8
$setglobal calc8 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc1 %storecalc1% %2 
$goto endcalcs
$label set9
$setglobal calc9 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc1 %storecalc1% %2 
$goto endcalcs
$label set10
$setglobal calc10 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc1 %storecalc1% %2 
$goto endcalcs

$label set11
$setglobal calc11 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc2 %2 
$goto endcalcs
$label set12
$setglobal calc12 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc2 %storecalc2% %2 
$goto endcalcs
$label set13
$setglobal calc13 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc2 %storecalc2% %2 
$goto endcalcs
$label set14
$setglobal calc14 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc2 %storecalc2% %2 
$goto endcalcs
$label set15
$setglobal calc15 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc2 %storecalc2% %2 
$goto endcalcs
$label set16
$setglobal calc16 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc2 %storecalc2% %2 
$goto endcalcs
$label set17
$setglobal calc17 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc2 %storecalc2% %2 
$goto endcalcs
$label set18
$setglobal calc18 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc2 %storecalc2% %2 
$goto endcalcs
$label set19
$setglobal calc19 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc2 %storecalc2% %2 
$goto endcalcs
$label set20
$setglobal calc20 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc2 %storecalc2% %2 
$goto endcalcs

$label set21
$setglobal calc21 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc3 %2 
$goto endcalcs
$label set22
$setglobal calc22 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc3 %storecalc3% %2 
$goto endcalcs
$label set23
$setglobal calc23 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc3 %storecalc3% %2 
$goto endcalcs
$label set24
$setglobal calc24 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc3 %storecalc3% %2 
$goto endcalcs
$label set25
$setglobal calc25 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc3 %storecalc3% %2 
$goto endcalcs
$label set26
$setglobal calc26 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc3 %storecalc3% %2 
$goto endcalcs
$label set27
$setglobal calc27 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc3 %storecalc3% %2 
$goto endcalcs
$label set28
$setglobal calc28 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc3 %storecalc3% %2 
$goto endcalcs
$label set29
$setglobal calc29 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc3 %storecalc3% %2 
$goto endcalcs
$label set30
$setglobal calc30 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc3 %storecalc3% %2 
$goto endcalcs

$label set31
$setglobal calc31 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc4 %2 
$goto endcalcs
$label set32
$setglobal calc32 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc4 %storecalc4% %2 
$goto endcalcs
$label set33
$setglobal calc33 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc4 %storecalc4% %2 
$goto endcalcs
$label set34
$setglobal calc34 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc4 %storecalc4% %2 
$goto endcalcs
$label set35
$setglobal calc35 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc4 %storecalc4% %2 
$goto endcalcs
$label set36
$setglobal calc36 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc4 %storecalc4% %2 
$goto endcalcs
$label set37
$setglobal calc37 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc4 %storecalc4% %2 
$goto endcalcs
$label set38
$setglobal calc38 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc4 %storecalc4% %2 
$goto endcalcs
$label set39
$setglobal calc39 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc4 %storecalc4% %2 
$goto endcalcs
$label set40
$setglobal calc40 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc4 %storecalc4% %2 
$goto endcalcs

$label set41
$setglobal calc41 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc5 %2 
$goto endcalcs
$label set42
$setglobal calc42 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc5 %storecalc5% %2 
$goto endcalcs
$label set43
$setglobal calc43 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc5 %storecalc5% %2 
$goto endcalcs
$label set44
$setglobal calc44 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc5 %storecalc5% %2 
$goto endcalcs
$label set45
$setglobal calc45 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc5 %storecalc5% %2 
$goto endcalcs
$label set46
$setglobal calc46 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc5 %storecalc5% %2 
$goto endcalcs
$label set47
$setglobal calc47 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc5 %storecalc5% %2 
$goto endcalcs
$label set48
$setglobal calc48 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc5 %storecalc5% %2 
$goto endcalcs
$label set49
$setglobal calc49 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc5 %storecalc5% %2 
$goto endcalcs
$label set50
$setglobal calc50 %2 %3 %4 %5 %6 %7 %8 %9
$setglobal storecalc5 %storecalc5% %2 
$goto endcalcs

$label endcalcs
$if not declared %2 parameter %2;
$goto end

*===============
$label end
